/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the GroupsAllowedToPost type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GroupsAllowedToPost{}

// GroupsAllowedToPost struct for GroupsAllowedToPost
type GroupsAllowedToPost struct {
	GroupMailSettingsId NullableString `json:"groupMailSettingsId,omitempty"`
	GroupId             NullableString `json:"groupId,omitempty"`
}

// NewGroupsAllowedToPost instantiates a new GroupsAllowedToPost object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGroupsAllowedToPost() *GroupsAllowedToPost {
	this := GroupsAllowedToPost{}
	return &this
}

// NewGroupsAllowedToPostWithDefaults instantiates a new GroupsAllowedToPost object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGroupsAllowedToPostWithDefaults() *GroupsAllowedToPost {
	this := GroupsAllowedToPost{}
	return &this
}

// GetGroupMailSettingsId returns the GroupMailSettingsId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupsAllowedToPost) GetGroupMailSettingsId() string {
	if o == nil || IsNil(o.GroupMailSettingsId.Get()) {
		var ret string
		return ret
	}
	return *o.GroupMailSettingsId.Get()
}

// GetGroupMailSettingsIdOk returns a tuple with the GroupMailSettingsId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupsAllowedToPost) GetGroupMailSettingsIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.GroupMailSettingsId.Get(), o.GroupMailSettingsId.IsSet()
}

// HasGroupMailSettingsId returns a boolean if a field has been set.
func (o *GroupsAllowedToPost) HasGroupMailSettingsId() bool {
	if o != nil && o.GroupMailSettingsId.IsSet() {
		return true
	}

	return false
}

// SetGroupMailSettingsId gets a reference to the given NullableString and assigns it to the GroupMailSettingsId field.
func (o *GroupsAllowedToPost) SetGroupMailSettingsId(v string) {
	o.GroupMailSettingsId.Set(&v)
}

// SetGroupMailSettingsIdNil sets the value for GroupMailSettingsId to be an explicit nil
func (o *GroupsAllowedToPost) SetGroupMailSettingsIdNil() {
	o.GroupMailSettingsId.Set(nil)
}

// UnsetGroupMailSettingsId ensures that no value is present for GroupMailSettingsId, not even an explicit nil
func (o *GroupsAllowedToPost) UnsetGroupMailSettingsId() {
	o.GroupMailSettingsId.Unset()
}

// GetGroupId returns the GroupId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupsAllowedToPost) GetGroupId() string {
	if o == nil || IsNil(o.GroupId.Get()) {
		var ret string
		return ret
	}
	return *o.GroupId.Get()
}

// GetGroupIdOk returns a tuple with the GroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupsAllowedToPost) GetGroupIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.GroupId.Get(), o.GroupId.IsSet()
}

// HasGroupId returns a boolean if a field has been set.
func (o *GroupsAllowedToPost) HasGroupId() bool {
	if o != nil && o.GroupId.IsSet() {
		return true
	}

	return false
}

// SetGroupId gets a reference to the given NullableString and assigns it to the GroupId field.
func (o *GroupsAllowedToPost) SetGroupId(v string) {
	o.GroupId.Set(&v)
}

// SetGroupIdNil sets the value for GroupId to be an explicit nil
func (o *GroupsAllowedToPost) SetGroupIdNil() {
	o.GroupId.Set(nil)
}

// UnsetGroupId ensures that no value is present for GroupId, not even an explicit nil
func (o *GroupsAllowedToPost) UnsetGroupId() {
	o.GroupId.Unset()
}

func (o GroupsAllowedToPost) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GroupsAllowedToPost) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.GroupMailSettingsId.IsSet() {
		toSerialize["groupMailSettingsId"] = o.GroupMailSettingsId.Get()
	}
	if o.GroupId.IsSet() {
		toSerialize["groupId"] = o.GroupId.Get()
	}
	return toSerialize, nil
}

type NullableGroupsAllowedToPost struct {
	value *GroupsAllowedToPost
	isSet bool
}

func (v NullableGroupsAllowedToPost) Get() *GroupsAllowedToPost {
	return v.value
}

func (v *NullableGroupsAllowedToPost) Set(val *GroupsAllowedToPost) {
	v.value = val
	v.isSet = true
}

func (v NullableGroupsAllowedToPost) IsSet() bool {
	return v.isSet
}

func (v *NullableGroupsAllowedToPost) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGroupsAllowedToPost(val *GroupsAllowedToPost) *NullableGroupsAllowedToPost {
	return &NullableGroupsAllowedToPost{value: val, isSet: true}
}

func (v NullableGroupsAllowedToPost) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGroupsAllowedToPost) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
